<?php

/**
 * LeadsEmailsequenceBanIpsMapper.php
 *
 *
 * @method Leads_Mapper_LeadsEmailsequenceBanIpsMapper   getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Leads_Mapper_LeadsEmailsequenceBanIpsMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsEmailsequenceBanIpsModel';

    protected $_dbTable = 'Leads_DbTable_LeadsEmailsequenceBanIpsDbTable';

    /**
     * Save lead task model to DB
     * @param $model Leads_Model_LeadsIpsModel
     * @return Leads_Model_LeadsIpsModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'ip_address' => $model->getIpAddress()
        );

        $ip = $data['ip_address'];
        $leadIpModel = $this->getByIp($ip);
        if (!$leadIpModel instanceof Leads_Model_LeadsIpsModel) {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        } else {
            $where = $this->getDbTable()->getAdapter()->quoteInto('ip_address = ?', $ip);
            $this->getDbTable()->update($data, $where);
        }

        return $model;
    }

    /**
     * Get by ip address
     *
     * @param string $ip ip address
     * @return null
     */
    public function getByIp($ip)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('ip_address = ?', $ip);
        return $this->_findWhere($where);
    }


}
