<?php

/**
 * Class Tools_LeadOpportunityTools
 */
class Tools_LeadOpportunityTools
{

    public static function processOpportunityFromQuote($quoteData, $leadId)
    {
        $quoteId = $quoteData['qid'];
        if (empty($quoteData['additionalInfo']['stageId'])) {
            return '';
        }

        $leadOpportunityStageMapper = Leads_Mapper_LeadsOpportunityStageMapper::getInstance();
        $stageId = $leadOpportunityStageMapper->getDefaultStage();
        if (!empty($stageId['0'])) {
            $stageId = $stageId['0']['id'];
        }

        $quoteMapper = Quote_Models_Mapper_QuoteMapper::getInstance();
        $quoteModel = $quoteMapper->find($quoteId);
        if ($quoteModel instanceof Quote_Models_Model_Quote && !empty($stageId)) {
            $createdAt = Tools_System_Tools::convertDateFromTimezone('now');
            $quoteTitle = $quoteModel->getTitle();
            $expiresAt = $quoteModel->getExpiresAt();
            $cartId = $quoteModel->getCartId();
            if (!empty($cartId)) {
                $session = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
                $creatorId = $session->getCurrentUser()->getId();
                $leadsOpportunityQuote = Leads_Mapper_LeadsOpportunityQuoteMapper::getInstance();
                $leadsOpportunityQuoteModel = $leadsOpportunityQuote->getByCartId($cartId);
                $leadOpportunityDataMapper = Leads_Mapper_LeadsOpportunityMapper::getInstance();
                if (!$leadsOpportunityQuoteModel instanceof Leads_Model_LeadsOpportunityQuoteModel) {
                    $ordersMapper = Models_Mapper_OrdersMapper::getInstance();
                    $ordersModel = $ordersMapper->find($cartId);
                    if ($ordersModel instanceof Models_Model_CartSession) {
                        $total = round($ordersModel->getTotal());
                        $leadsOpportunityModel = $leadOpportunityDataMapper->getOpportunityByOpportunityNameStageIdLeadId($quoteTitle, $stageId, $leadId);
                        if (!$leadsOpportunityModel instanceof Leads_Model_LeadsOpportunityModel) {
                            $leadsOpportunityModel = new Leads_Model_LeadsOpportunityModel();
                            $leadsOpportunityModel->setOpportunityName($quoteTitle);
                            $leadsOpportunityModel->setOpportunityTypeId(0);
                            $leadsOpportunityModel->setExpectedCloseDate($expiresAt);
                            $leadsOpportunityModel->setOpportunityValue($total);
                            $leadsOpportunityModel->setCreatorId($creatorId);
                            $leadsOpportunityModel->setLeadId($leadId);
                            $leadsOpportunityModel->setOpportunityStageId($stageId);
                            $leadsOpportunityModel->setCreatedAt($createdAt);
                        }

                        $leadOpportunityDataMapper->save($leadsOpportunityModel);

                        $opportunityId = $leadsOpportunityModel->getId();

                        $leadsOpportunityQuoteMapper = Leads_Mapper_LeadsOpportunityQuoteMapper::getInstance();
                        $leadOpportunityQuoteModel = new Leads_Model_LeadsOpportunityQuoteModel();
                        $leadOpportunityQuoteModel->setOpportunityId($opportunityId);
                        $leadOpportunityQuoteModel->setQuoteId($quoteId);
                        $leadOpportunityQuoteModel->setLeadId($leadId);
                        $leadOpportunityQuoteModel->setCartId($cartId);
                        $leadOpportunityQuoteModel->setCreatedAt($createdAt);
                        $leadsOpportunityQuoteMapper->save($leadOpportunityQuoteModel);

                    }
                }
            }
        }
    }
}
