<?php

/**
 * Class Lead_LeadSearchSettingsTools
 */
class Tools_LeadSearchSettingsTools
{
    const CRM_TAB_CONFIG_GENERAL = 'general';

    const CRM_TAB_CONFIG_IMPORT_CONTACTS = 'crmImportLeadsAndOrganizations';

    const CRM_TAB_CONFIG_CLOUD_TRACKING = 'crmLeadsCloudTrackingServices';

    const CRM_TAB_CONFIG_OPPORTUNITY_STAGES = 'crmConfigOpportunitystage';

    const CRM_TAB_CONFIG_OPPORTUNITY_TYPES = 'crmConfigOpportunityTypes';

    const CRM_TAB_CONFIG_LEAD_CONFIG = 'crmConfigLeadGeneral';

    const CRM_TAB_CONFIG_LEAD_GOALS_AND_QUOTES = 'goalConfig';

    const CRM_TAB_CONFIG_LEAD_TYPE = 'crmConfigLead';

    const CRM_TAB_CONFIG_LEAD_SOURCE = 'crmConfigLeadSource';

    const CRM_TAB_CONFIG_LEAD_LIFECYCLE_STAGE = 'crmConfigStage';

    const CRM_TAB_CONFIG_LEAD_TAGS = 'crmConfigLeadTags';

    const CRM_TAB_CONFIG_EXTERNAL_EVENTS = 'crmConfigLeadEvents';

    const CRM_TAB_CONFIG_SOCIAL_SERVICES = 'crmConfigSocialServices';

    const CRM_TAB_CONFIG_ORGANIZATION_INDUSTRIES = 'crmConfigIndustry';

    const CRM_TAB_CONFIG_CUSTOM_LEAD_FIELDS = 'crmConfigLeadCustomParams';

    const CRM_TAB_CONFIG_CUSTOM_ORGANIZATION_FIELDS = 'crmConfigOrganizationCustomParams';

    const CRM_TAB_CONFIG_CUSTOM_FIELDS_FIELDS_FOR_LEADS_ORGANIZATIONS = 'crmConfigOrganizeCustomFields';

    const CRM_TAB_CONFIG_LEAD_ORGANIZATION_CUSTOM_TABS = 'crmCustomTabsConfig';

    const CRM_TAB_CONFIG_CONFIGURATION_EMAIL_IMAP = 'crmInboundEmailsConfig';

    const CRM_TAB_CONFIG_CONFIGURATION_INBOUND_LEAD_RULES = 'crmImapRulesConfig';

    const CRM_TAB_CONFIG_TASK_CONFIGURATION = 'crmTasksConfig';

    const CRM_TAB_CONFIG_CRM_API_ACCESS = 'crmApiConfig';

    const CRM_TAB_CONFIG_WEBHOOK_URLS = 'crmWebhookUrlsConfig';


    public static $_tabsInfo = array(
        self::CRM_TAB_CONFIG_GENERAL => array('tabName' => self::CRM_TAB_CONFIG_GENERAL, 'tabLabel' => 'General', 'tabPosition' => '1'),
        self::CRM_TAB_CONFIG_IMPORT_CONTACTS => array('tabName' => self::CRM_TAB_CONFIG_IMPORT_CONTACTS, 'tabLabel' => 'Import contacts data', 'tabPosition' => '1'),
        self::CRM_TAB_CONFIG_CLOUD_TRACKING => array('tabName' => self::CRM_TAB_CONFIG_CLOUD_TRACKING, 'tabLabel' => 'Cloud tracking services', 'tabPosition' => '100'),
        self::CRM_TAB_CONFIG_OPPORTUNITY_STAGES => array('tabName' => self::CRM_TAB_CONFIG_OPPORTUNITY_STAGES, 'tabLabel' => 'Opportunity stages', 'tabPosition' => '200'),
        self::CRM_TAB_CONFIG_OPPORTUNITY_TYPES => array('tabName' => self::CRM_TAB_CONFIG_OPPORTUNITY_TYPES, 'tabLabel' => 'Opportunity types', 'tabPosition' => '350'),
        self::CRM_TAB_CONFIG_LEAD_CONFIG => array('tabName' => self::CRM_TAB_CONFIG_LEAD_CONFIG, 'tabLabel' => 'Lead config', 'tabPosition' => '500'),
        self::CRM_TAB_CONFIG_LEAD_GOALS_AND_QUOTES => array('tabName' => self::CRM_TAB_CONFIG_LEAD_GOALS_AND_QUOTES, 'tabLabel' => 'Goals and Quotas', 'tabPosition' => '550'),
        self::CRM_TAB_CONFIG_LEAD_TYPE => array('tabName' => self::CRM_TAB_CONFIG_LEAD_TYPE, 'tabLabel' => 'Lead type', 'tabPosition' => '700'),
        self::CRM_TAB_CONFIG_LEAD_SOURCE => array('tabName' => self::CRM_TAB_CONFIG_LEAD_SOURCE, 'tabLabel' => 'Lead source', 'tabPosition' => '800'),
        self::CRM_TAB_CONFIG_LEAD_LIFECYCLE_STAGE => array('tabName' => self::CRM_TAB_CONFIG_LEAD_LIFECYCLE_STAGE, 'tabLabel' => 'Lead lifecycle stage', 'tabPosition' => '900'),
        self::CRM_TAB_CONFIG_LEAD_TAGS => array('tabName' => self::CRM_TAB_CONFIG_LEAD_TAGS, 'tabLabel' => 'Lead tags', 'tabPosition' => '1150'),
        self::CRM_TAB_CONFIG_EXTERNAL_EVENTS => array('tabName' => self::CRM_TAB_CONFIG_EXTERNAL_EVENTS, 'tabLabel' => 'External events', 'tabPosition' => '1200'),
        self::CRM_TAB_CONFIG_SOCIAL_SERVICES => array('tabName' => self::CRM_TAB_CONFIG_SOCIAL_SERVICES, 'tabLabel' => 'Lead social services', 'tabPosition' => '1300'),
        self::CRM_TAB_CONFIG_ORGANIZATION_INDUSTRIES => array('tabName' => self::CRM_TAB_CONFIG_ORGANIZATION_INDUSTRIES, 'tabLabel' => 'Organization\'s industries', 'tabPosition' => '1350'),
        self::CRM_TAB_CONFIG_CUSTOM_LEAD_FIELDS => array('tabName' => self::CRM_TAB_CONFIG_CUSTOM_LEAD_FIELDS, 'tabLabel' => 'Custom lead fields', 'tabPosition' => '1600'),
        self::CRM_TAB_CONFIG_CUSTOM_ORGANIZATION_FIELDS => array('tabName' => self::CRM_TAB_CONFIG_CUSTOM_ORGANIZATION_FIELDS, 'tabLabel' => 'Custom organization fields', 'tabPosition' => '1700'),
        self::CRM_TAB_CONFIG_CUSTOM_FIELDS_FIELDS_FOR_LEADS_ORGANIZATIONS => array('tabName' => self::CRM_TAB_CONFIG_CUSTOM_FIELDS_FIELDS_FOR_LEADS_ORGANIZATIONS, 'tabLabel' => 'Organize custom fields for leads/organizations', 'tabPosition' => '2000'),
        self::CRM_TAB_CONFIG_LEAD_ORGANIZATION_CUSTOM_TABS => array('tabName' => self::CRM_TAB_CONFIG_LEAD_ORGANIZATION_CUSTOM_TABS, 'tabLabel' => 'Leads/Organization custom tabs', 'tabPosition' => '2200'),
        self::CRM_TAB_CONFIG_CONFIGURATION_EMAIL_IMAP => array('tabName' => self::CRM_TAB_CONFIG_CONFIGURATION_EMAIL_IMAP, 'tabLabel' => 'Configuration email IMAP', 'tabPosition' => '2300'),
        self::CRM_TAB_CONFIG_CONFIGURATION_INBOUND_LEAD_RULES => array('tabName' => self::CRM_TAB_CONFIG_CONFIGURATION_INBOUND_LEAD_RULES, 'tabLabel' => 'Imap inbound lead rules', 'tabPosition' => '2500'),
        self::CRM_TAB_CONFIG_TASK_CONFIGURATION => array('tabName' => self::CRM_TAB_CONFIG_TASK_CONFIGURATION, 'tabLabel' => 'Tasks configuration', 'tabPosition' => '2600'),
        self::CRM_TAB_CONFIG_CRM_API_ACCESS => array('tabName' => self::CRM_TAB_CONFIG_CRM_API_ACCESS, 'tabLabel' => 'Crm Api access', 'tabPosition' => '2600'),
        self::CRM_TAB_CONFIG_WEBHOOK_URLS => array('tabName' => self::CRM_TAB_CONFIG_WEBHOOK_URLS, 'tabLabel' => 'Webhook URL\'s', 'tabPosition' => '2700'),
    );


    public static $_tabsSearchInfo = array(
        self::CRM_TAB_CONFIG_GENERAL => 'General',
        self::CRM_TAB_CONFIG_IMPORT_CONTACTS => 'Import contacts data',
        self::CRM_TAB_CONFIG_CLOUD_TRACKING => 'Cloud tracking services',
        self::CRM_TAB_CONFIG_OPPORTUNITY_STAGES => 'Opportunity stages',
        self::CRM_TAB_CONFIG_OPPORTUNITY_TYPES => 'Opportunity types',
        self::CRM_TAB_CONFIG_LEAD_CONFIG => 'Lead config',
        self::CRM_TAB_CONFIG_LEAD_GOALS_AND_QUOTES => 'Goals and Quotas',
        self::CRM_TAB_CONFIG_LEAD_TYPE => 'Lead type',
        self::CRM_TAB_CONFIG_LEAD_SOURCE => 'Lead source',
        self::CRM_TAB_CONFIG_LEAD_LIFECYCLE_STAGE => 'Lead lifecycle stage',
        self::CRM_TAB_CONFIG_LEAD_TAGS => 'Lead tags',
        self::CRM_TAB_CONFIG_EXTERNAL_EVENTS => 'External events',
        self::CRM_TAB_CONFIG_SOCIAL_SERVICES => 'Lead social services',
        self::CRM_TAB_CONFIG_ORGANIZATION_INDUSTRIES => 'Organization\'s industries',
        self::CRM_TAB_CONFIG_CUSTOM_LEAD_FIELDS => 'Custom lead fields',
        self::CRM_TAB_CONFIG_CUSTOM_ORGANIZATION_FIELDS => 'Custom organization fields',
        self::CRM_TAB_CONFIG_CUSTOM_FIELDS_FIELDS_FOR_LEADS_ORGANIZATIONS => 'Organize custom fields for leads/organizations',
        self::CRM_TAB_CONFIG_LEAD_ORGANIZATION_CUSTOM_TABS => 'Leads/Organization custom tabs',
        self::CRM_TAB_CONFIG_CONFIGURATION_EMAIL_IMAP => 'Configuration email IMAP',
        self::CRM_TAB_CONFIG_CONFIGURATION_INBOUND_LEAD_RULES => 'Imap inbound lead rules',
        self::CRM_TAB_CONFIG_TASK_CONFIGURATION => 'Tasks configuration',
        self::CRM_TAB_CONFIG_CRM_API_ACCESS => 'Crm Api access',
        self::CRM_TAB_CONFIG_WEBHOOK_URLS => 'Webhook URL\'s',
    );


    /**
     * Search crm config screen tabs
     *
     * @param string $search search param
     * @return array
     */
    public static function searchConfigTab($search)
    {

        $result = array();

        $searchResult = preg_grep('~' . $search . '.*~ui', self::$_tabsSearchInfo);
        if (empty($searchResult)) {
            return array();
        }

        foreach ($searchResult as $tabName => $val) {
            array_push($result, self::$_tabsInfo[$tabName]);
        }

        return $result;
    }
}
