<?php

class Widgets_Leadmassactionsqueue_Leadmassactionsqueue extends Widgets_Abstract
{

    /**
     * Website helper
     *
     * @var null
     */
    protected $_websiteHelper = null;

    /**
     * @var bool
     */
    protected $_cacheable = false;

    /**
     * Session helper
     *
     * @var bool
     */
    protected $_sessionHelper = false;

    /**
     * @var null
     */
    protected $_layout = null;

    /**
     *
     * @var Leads_Model_LeadsMassActionsQueueModel
     */
    protected $_leadsMassactionsqueueModel = null;

    protected function _init()
    {
        parent::_init();
        $this->_view = new Zend_View(array(
            'scriptPath' => __DIR__ . '/views/'
        ));


        $this->_layout = new Zend_Layout();
        $this->_layout->setLayoutPath(Zend_Layout::getMvcInstance()->getLayoutPath());

        $this->_websiteHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('website');
        $this->_view->websiteUrl = $this->_websiteHelper->getUrl();
        $this->_websiteUrl = $this->_websiteHelper->getUrl();
        $this->_translator = Zend_Registry::get('Zend_Translate');

        $this->_view->setHelperPath(APPLICATION_PATH . '/views/helpers/');
        $this->_view->addHelperPath('ZendX/JQuery/View/Helper/', 'ZendX_JQuery_View_Helper');
        $this->_view->addScriptPath($this->_websiteHelper->getPath() . 'seotoaster_core/application/views/scripts/');
        // init helpers
        $this->_configHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('config');
        $this->_sessionHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
    }

    protected function _load()
    {
        if (empty($this->_options[0])) {
            return $this->_translator->translate(Leads::TRANSLATION_PREFIX . 'Option not specified');
        }

        if (!empty($this->_toasterOptions['observableModel']) && is_object($this->_toasterOptions['observableModel'])) {
            $observableModel = $this->_toasterOptions['observableModel'];
            if ($observableModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
                $this->_leadsMassactionsqueueModel = $observableModel;
            }
        }

        $methodName = '_render' . ucfirst($this->_options[0]);
        if (method_exists($this, $methodName)) {
            return $this->$methodName();

        }

        return $this->_translator->translate(Leads::TRANSLATION_PREFIX . 'Method doesn\'t exists');
    }

    /**
     * @return string
     */
    protected function _renderCreatedat()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            $createdAt = $this->_leadsMassactionsqueueModel->getCreatedAt();
            $shoppingConfig = Models_Mapper_ShoppingConfig::getInstance();
            $systemTimezone = $shoppingConfig->getConfigParam('timezone');
            if (!empty($systemTimezone)) {
                $date = Tools_System_Tools::convertDateFromTimezone($createdAt, $systemTimezone, 'UTC', 'd-M-Y H:i:s');
            } else {
                $date = Tools_System_Tools::convertDateFromTimezone($createdAt, 'UTC', 'UTC', 'd-M-Y H:i:s');
            }

            return $date;

        } else {
            return '{$leademailvalidation:createdat}';
        }
    }


    /**
     * @return string
     */
    protected function _renderProcessedat()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            $processedAt = $this->_leadsMassactionsqueueModel->getProcessedAt();
            $shoppingConfig = Models_Mapper_ShoppingConfig::getInstance();
            $systemTimezone = $shoppingConfig->getConfigParam('timezone');
            if (!empty($systemTimezone)) {
                $date = Tools_System_Tools::convertDateFromTimezone($processedAt, $systemTimezone, 'UTC', 'd-M-Y H:i:s');
            } else {
                $date = Tools_System_Tools::convertDateFromTimezone($processedAt, 'UTC', 'UTC', 'd-M-Y H:i:s');
            }

            return $date;

        } else {
            return '{$leademailvalidation:processedat}';
        }
    }

    /**
     * @return string
     */
    protected function _renderTotal()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            return ((int)$this->_leadsMassactionsqueueModel->getNotProcessedLeads() + (int)$this->_leadsMassactionsqueueModel->getProcessedLeads());

        } else {
            return '{$leademailvalidation:total}';
        }
    }

    /**
     * @return string
     */
    protected function _renderProcessed()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            return (int)$this->_leadsMassactionsqueueModel->getProcessedLeads();

        } else {
            return '{$leademailvalidation:processed}';
        }
    }

    /**
     * @return string
     */
    protected function _renderNotprocessed()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            return (int)$this->_leadsMassactionsqueueModel->getNotProcessedLeads();

        } else {
            return '{$leademailvalidation:notprocessed}';
        }
    }

    /**
     * @return string
     */
    protected function _renderBalance()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            return (int)$this->_leadsMassactionsqueueModel->getBalance();

        } else {
            return '{$leademailvalidation:balance}';
        }
    }

    /**
     * @return string
     */
    protected function _renderCreator()
    {
        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            $creatorId = $this->_leadsMassactionsqueueModel->getCreatorId();
            $userMapper = Application_Model_Mappers_UserMapper::getInstance();
            $userModel = $userMapper->find($creatorId);
            if ($userModel instanceof Application_Model_Models_User) {
                return $userModel->getFullName();
            }

            return '';

        } else {
            return '{$leademailvalidation:creator}';
        }
    }

    /**
     * @return string
     */
    protected function _renderAdditionaldata()
    {
        if (empty($this->_options['1'])) {
            return '';
        }

        if ($this->_leadsMassactionsqueueModel instanceof Leads_Model_LeadsMassActionsQueueModel) {
            $additionalData = json_decode($this->_leadsMassactionsqueueModel->getAdditionalData(), true);
            if (empty($additionalData)) {
                return '';
            }

            $paramName = $this->_options['1'];
            if (empty($additionalData[$paramName])) {
                return '';
            }

            return $additionalData[$paramName];


        } else {
            return '{$leademailvalidation:additionaldata:optionname}';
        }

    }


}
